#!/bin/bash
###########################################################################################
##      					Mundo Choc Cac
##  Author : 
##	Home Page 	: http://wiki.qt.io/Build_Qt5_postgresql_plugin_for_Android
##  Author    	: Mynor Rene Choc Cac <mynorrene@choccac.com>
##	Home Page 	: http://www.mynorrene.choccac.com
##  Project   	: Driver Postgres
##  Date      	: 2015-06-08T16:06:39
##  License   	: GPL3 and Digia
##  Comment   	: none
##  Plataform 	: android_armv5, android_armv7 y android_x86.
##  FileName  	: libqsqlpsql.so
##  Dependency	: 	libpq.so
## 					liblog.so
##					libz.so
##					libdl.so
##					libstdc++.so
##					libm.so
##					libc.so
##
##  This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
##  WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
## 
###########################################################################################
#http://wiki.qt.io/Build_Qt5_postgresql_plugin_for_Android
here="$(readlink -e "$(dirname "$0")")"
echo ""
echo ""
echo "Adaptado por MundoChocCac"
echo "http://www.choccac.com"
echo ""
echo ""
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++5960 5928
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#================Configuracion del entorno============================

## Sdk Qt.
# Ruta de la carpeta ejemplo QTx.x.x/x.x
# path to folder the Qt example QTx.x.x/x.x
lugarSr="/home/"$USER"/Qt5.5.0/5.5"

## Src postgres search home page version, copy and paste name.
# Version postgresql-x.x.x
versionPostgre="postgresql-9.4.1"

## NDK Android
# ruta de la carpeta de android-ndk-r10X
# path to folder the android-ndk-r10X
miSdk="/home/"$USER"/Android/android-ndk-r10e"
# platforms = se esta usando android-9
# platforms = use android-9
miplafaforms="9"
# toolchains = actualmente Qt usa 4.9
# toolchains =  Qt use 4.9
mitoolchains="4.9"

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

echo "1. android_armv5"
echo "2. android_armv7"
echo "3. android_x86"
printf "Driver Postgres: "
read miDriverCompi

xmipla=$(uname -m)

if [ $miDriverCompi = 1 ];
then
	echo "Compilando android_armv5"
	driverQT="android_armv5"
	export ANDROID_NDK_ROOT=$miSdk
	SR="$ANDROID_NDK_ROOT/platforms/android-"$miplafaforms"/arch-arm"
	
	if [ $xmipla = "x86_64" ];
	then
		echo "machine: x86_64"
		BR="$ANDROID_NDK_ROOT/toolchains/arm-linux-androideabi-"$mitoolchains"/prebuilt/linux-"$xmipla"/bin/arm-linux-androideabi-"
	fi

	if [ $xmipla = "i686" ];
	then
		echo "machine: i686"
		BR="$ANDROID_NDK_ROOT/toolchains/arm-linux-androideabi-"$mitoolchains"/prebuilt/linux-x86/bin/arm-linux-androideabi-"
	fi
fi

if [ $miDriverCompi = 2 ];
then
	echo "Compilando android_armv7"
	driverQT="android_armv7"
	export ANDROID_NDK_ROOT=$miSdk
	SR="$ANDROID_NDK_ROOT/platforms/android-"$miplafaforms"/arch-arm"
	
	if [ $xmipla = "x86_64" ];
	then
		echo "machine: x86_64"
		BR="$ANDROID_NDK_ROOT/toolchains/arm-linux-androideabi-"$mitoolchains"/prebuilt/linux-"$xmipla"/bin/arm-linux-androideabi-"
	fi
	
	if [ $xmipla = "i686" ];
	then
		echo "machine: i686"
		BR="$ANDROID_NDK_ROOT/toolchains/arm-linux-androideabi-"$mitoolchains"/prebuilt/linux-x86/bin/arm-linux-androideabi-"
	fi
fi

if [ $miDriverCompi = 3 ];
then
	echo "Compilando android_x86"
	driverQT="android_x86"
	export ANDROID_NDK_ROOT=$miSdk
	SR="$ANDROID_NDK_ROOT/platforms/android-"$miplafaforms"/arch-x86"

	if [ $xmipla = "x86_64" ];
	then
		echo "machine: x86_64"
		BR="$ANDROID_NDK_ROOT/toolchains/x86-"$mitoolchains"/prebuilt/linux-"$xmipla"/bin/i686-linux-android-"
	fi
	
	if [ $xmipla = "i686" ];
	then
		echo "machine: i686"
		BR="$ANDROID_NDK_ROOT/toolchains/x86-"$mitoolchains"/prebuilt/linux-x86/bin/i686-linux-android-"
	fi
fi

find "$SR" > "$here/rootfs_files_before.txt" || exit 1
checkChanges() {
        find "$SR" > "$here/rootfs_files_after.txt" || exit 1
        echo "Cambios:"
        diff -u "$here/rootfs_files_before.txt" "$here/rootfs_files_after.txt"
}
trap checkChanges EXIT

newVersion=$versionPostgre".tar.bz2"
lugar3=$PWD"/"$newVersion
rm -R $PWD"/"$versionPostgre
pkg=$newVersion
dir=$(basename $pkg .tar.gz)

if [ ! -d $dir ]; then
        [ -f $pkg ] || wget https://ftp.postgresql.org/pub/source/v9.4.1/$pkg
        tar -xf $pkg || exit 1
fi

lugar=$lugarSr"/Src/qtbase/src/plugins/sqldrivers/psql"
lugar2=$lugarSr"/"$driverQT"/bin/qmake"

lugar3=$PWD"/"$versionPostgre
pushd $lugar3
	sed -i -e 's/lib$(NAME)$(DLSUFFIX).$(SO_MAJOR_VERSION).$(SO_MINOR_VERSION)/lib$(NAME)$(DLSUFFIX)/g' -i src/Makefile.shlib
	sed -i -e 's/lib$(NAME)$(DLSUFFIX).$(SO_MAJOR_VERSION)/lib$(NAME)$(DLSUFFIX)/g' -i src/Makefile.shlib
	STRIP="$BR"strip RANLIB="$BR"ranlib OBJDUMP="$BR"objdump AR="$BR"ar CC="$BR"gcc CFLAGS=--sysroot=$SR CPP="$BR"cpp CPPFLAGS=$CFLAGS \
	./configure --prefix=$SR/usr --host=arm-linux-androideabi --target=arm-linux-androideabi --build="$CHOST" --without-readline --with-system-tzdata=$lugar3/src/timezone/data/
	make -C src/interfaces/libpq || exit 1
popd


pushd $lugar
    qmake=$lugar2
    $qmake "INCLUDEPATH+="$lugar3"/src/interfaces/libpq "$lugar3"/src/include" "LIBS+=-L"$lugar3"/src/interfaces/libpq/ -lpq"
    make || exit 1
	make install || exit 1
popd
echo ""
echo ""
echo "Dependecias necesarias par que se puede ejecutar el driver de postgres."
echo "esta deben incluirse manualmente desde QtCreator."
echo "->libpq.so"
echo "->libQt5Sql.so se incluye en el apk automaticamente"
echo "->libQt5Core.so se incluye en el apk automaticamente"
echo "->libgnustl_shared.so se incluye en el apk automaticamente"
echo "->liblog.so"
echo "->libz.so"
echo "->libdl.so"
echo "->libstdc++.so"
echo "->libm.so"
echo "->libc.so"
echo ""
echo ""
rm -R $lugarSr"/"$driverQT"/plugins/sqldrivers/postgres"
mkdir $lugarSr"/"$driverQT"/plugins/sqldrivers/postgres"
rm -R $lugarSr"/Src/qtbase/src/plugins/sqldrivers/psql/Makefile"
rm -R $lugarSr"/Src/qtbase/src/plugins/sqldrivers/psql/.moc"
rm -R $lugarSr"/Src/qtbase/src/plugins/sqldrivers/psql/.obj"
rm -R $lugarSr"/Src/qtbase/src/plugins/sqldrivers/psql/.pch"
cp $lugar3"/src/interfaces/libpq/libpq.so" $lugarSr"/"$driverQT"/plugins/sqldrivers/postgres/libpq.so"
cp $SR"/usr/lib/liblog.so" $lugarSr"/"$driverQT"/plugins/sqldrivers/postgres/liblog.so"
cp $SR"/usr/lib/libz.so" $lugarSr"/"$driverQT"/plugins/sqldrivers/postgres/libz.so"
cp $SR"/usr/lib/libdl.so" $lugarSr"/"$driverQT"/plugins/sqldrivers/postgres/libdl.so"
cp $SR"/usr/lib/libstdc++.so" $lugarSr"/"$driverQT"/plugins/sqldrivers/postgres/libstdc++.so"
cp $SR"/usr/lib/libm.so" $lugarSr"/"$driverQT"/plugins/sqldrivers/postgres/libm.so"
cp $SR"/usr/lib/libc.so" $lugarSr"/"$driverQT"/plugins/sqldrivers/postgres/libc.so"
echo ""
echo ""
echo "Adaptado por MundoChocCac"
echo "http://www.choccac.com"
echo ""
echo ""
echo "Terminado con exito."
